From c017feb1b602ab0a1a6b90d73323f4f54bf407b9 Mon Sep 17 00:00:00 2001
From: GONG Jie <jgong@suse.com>
Date: Mon, 24 Feb 2025 14:51:50 +0800
Subject: [PATCH] asn1_der_decoding2: optimize _asn1_find_up call with node
 cache

If we are parsing a sequence or set and the current node is a direct
child of it, there is no need to traverse the list back to the
leftmost one as we have a node cache.

diff --git a/lib/element.c b/lib/element.c
index ac30e46..1d498df 100644
--- a/lib/element.c
+++ b/lib/element.c
@@ -32,6 +32,8 @@
 #include "structure.h"
 
 #include "element.h"
+#include <limits.h>
+#include "intprops.h"
 
 void
 _asn1_hierarchical_name (asn1_node node, char *name, int name_size)
@@ -128,6 +130,41 @@ _asn1_convert_integer (const unsigned char *value, unsigned char *value_out,
   return ASN1_SUCCESS;
 }
 
+int
+_asn1_node_array_set (struct asn1_node_array_st *array, size_t position,
+                      asn1_node node)
+{
+  if (position >= array->size)
+    {
+      size_t new_size = position, i;
+      asn1_node *new_nodes;
+
+      if (INT_MULTIPLY_OVERFLOW (new_size, 2))
+        return ASN1_GENERIC_ERROR;
+      new_size *= 2;
+
+      if (INT_ADD_OVERFLOW (new_size, 1))
+        return ASN1_GENERIC_ERROR;
+      new_size += 1;
+
+      if (INT_MULTIPLY_OVERFLOW (new_size, sizeof (*new_nodes)))
+        return ASN1_GENERIC_ERROR;
+
+      new_nodes = realloc (array->nodes, new_size * sizeof (*new_nodes));
+      if (!new_nodes)
+        return ASN1_MEM_ALLOC_ERROR;
+
+      for (i = array->size; i < new_size; i++)
+        new_nodes[i] = NULL;
+
+      array->nodes = new_nodes;
+      array->size = new_size;
+    }
+
+  array->nodes[position] = node;
+  return ASN1_SUCCESS;
+}
+
 
 int
 _asn1_append_sequence_set (asn1_node node)
@@ -135,6 +172,7 @@ _asn1_append_sequence_set (asn1_node node)
   asn1_node p, p2;
   char temp[LTOSTR_MAX_SIZE];
   long n;
+  int result;
 
   if (!node || !(node->down))
     return ASN1_GENERIC_ERROR;
@@ -148,17 +186,21 @@ _asn1_append_sequence_set (asn1_node node)
     p = p->right;
   _asn1_set_right (p, p2);
 
-  if (p->name[0] == 0)
-    _asn1_str_cpy (temp, sizeof (temp), "?1");
-  else
+  n = 0;
+  if (p->name[0] != 0)
     {
-      n = strtol (p->name + 1, NULL, 0);
-      n++;
-      temp[0] = '?';
-      _asn1_ltostr (n, temp + 1);
+      n = strtol (p->name + 1, NULL, 10);
+      if (n <= 0 || n >= LONG_MAX - 1)
+	return ASN1_GENERIC_ERROR;
     }
+  temp[0] = '?';
+  _asn1_ltostr (n + 1, temp + 1);
   _asn1_set_name (p2, temp);
   /*  p2->type |= CONST_OPTION; */
+  result = _asn1_node_array_set (&node->numbered_children, n, p2);
+  if (result != ASN1_SUCCESS)
+    return result;
+  p2->parent = node;
 
   return ASN1_SUCCESS;
 }
diff --git a/lib/element.h b/lib/element.h
index fdecafb..3bb57c0 100644
--- a/lib/element.h
+++ b/lib/element.h
@@ -31,4 +31,14 @@ int _asn1_convert_integer (const unsigned char *value,
 
 void _asn1_hierarchical_name (asn1_node node, char *name, int name_size);
 
+static inline asn1_node_const
+_asn1_node_array_get (const struct asn1_node_array_st *array, size_t position)
+{
+  return position < array->size ? array->nodes[position] : NULL;
+}
+
+int
+_asn1_node_array_set (struct asn1_node_array_st *array, size_t position,
+                      asn1_node node);
+
 #endif
diff --git a/lib/int.h b/lib/int.h
index 72d2c4d..370fa93 100644
--- a/lib/int.h
+++ b/lib/int.h
@@ -40,6 +40,12 @@
 
 #define ASN1_SMALL_VALUE_SIZE 16
 
+struct asn1_node_array_st
+{
+  asn1_node *nodes;
+  size_t size;
+};
+
 /* This structure is also in libtasn1.h, but then contains less
    fields.  You cannot make any modifications to these first fields
    without breaking ABI.  */
@@ -56,6 +62,8 @@ struct asn1_node_st
   asn1_node left;		/* Pointer to the next list element */
   /* private fields: */
   unsigned char small_value[ASN1_SMALL_VALUE_SIZE];	/* For small values */
+  asn1_node parent;		/* Pointer to the parent node */
+  struct asn1_node_array_st numbered_children; /* Array of unnamed child nodes for caching */
 };
 
 typedef struct tag_and_class_st
diff --git a/lib/libtasn1.h b/lib/libtasn1.h
index 4ba5d1d..1f4177b 100644
--- a/lib/libtasn1.h
+++ b/lib/libtasn1.h
@@ -128,6 +128,7 @@ extern "C"
   typedef struct asn1_node_st asn1_node_st;
 
   typedef asn1_node_st *asn1_node;
+  typedef const asn1_node_st *asn1_node_const;
 
   /* maximum number of characters of a name */
   /* inside a file with ASN1 definitons     */
diff --git a/lib/parser_aux.c b/lib/parser_aux.c
index 20cf66e..a2d5d97 100644
--- a/lib/parser_aux.c
+++ b/lib/parser_aux.c
@@ -20,6 +20,7 @@
  */
 
 #include <int.h>
+#include <limits.h>
 #include <hash-pjw-bare.h>
 #include "parser_aux.h"
 #include "gstr.h"
@@ -98,6 +99,7 @@ asn1_find_node (asn1_node pointer, const char *name)
   const char *n_start;
   unsigned int nsize;
   unsigned int nhash;
+  const struct asn1_node_array_st *numbered_children;
 
   if (pointer == NULL)
     return NULL;
@@ -169,6 +171,7 @@ asn1_find_node (asn1_node pointer, const char *name)
       if (p->down == NULL)
 	return NULL;
 
+      numbered_children = &p->numbered_children;
       p = p->down;
 
       /* The identifier "?LAST" indicates the last element
@@ -182,6 +185,12 @@ asn1_find_node (asn1_node pointer, const char *name)
 	}
       else
 	{			/* no "?LAST" */
+         if (n[0] == '?' && isdigit (n[1]))
+           {
+             long position = strtol (n + 1, NULL, 10);
+             if (position > 0 && position < LONG_MAX)
+               p = _asn1_node_array_get (numbered_children, position - 1);
+           }
 	  while (p)
 	    {
 	      if (p->name_hash == nhash && !strcmp (p->name, n))
@@ -468,6 +477,8 @@ _asn1_remove_node (asn1_node node, unsigned int flags)
       if (node->value != node->small_value)
         free (node->value);
     }
+
+  free (node->numbered_children.nodes);
   free (node);
 }
 
diff --git a/lib/structure.c b/lib/structure.c
index 27fbfe3..d30ba30 100644
--- a/lib/structure.c
+++ b/lib/structure.c
@@ -31,7 +31,9 @@
 #include <structure.h>
 #include "parser_aux.h"
 #include <gstr.h>
-
+#include "element.h"
+#include <limits.h>
+#include <ctype.h>
 
 extern char _asn1_identifierMissing[];
 
@@ -375,6 +377,16 @@ asn1_delete_element (asn1_node structure, const char *element_name)
   if (source_node == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
 
+  if (source_node->parent
+      && source_node->name[0] == '?'
+      && isdigit (source_node->name[1]))
+    {
+      long position = strtol (source_node->name + 1, NULL, 10);
+      if (position > 0 && position < LONG_MAX)
+        _asn1_node_array_set (&source_node->parent->numbered_children,
+                              position - 1, NULL);
+    }
+
   p2 = source_node->right;
   p3 = _asn1_find_left (source_node);
   if (!p3)
-- 
2.46.1

